package com.sun.org.apache.xml.internal.utils;

public class Trie
{
    public static final int ALPHA_SIZE = 128;
    Trie.Node m_Root;
    private char[] m_charBuffer;
    
    public Trie() {
        this.m_charBuffer = new char[0];
        this.m_Root = new Trie.Node();
    }
    
    public Object put(String key, Object value) {
        int len = key.length();
        if (len > this.m_charBuffer.length) {
            this.m_charBuffer = new char[len];
        }
        Trie.Node node = this.m_Root;
        int i = 0;
        while (i < len) {
            Trie.Node nextNode = node.m_nextChar[Character.toUpperCase(key.charAt(i))];
            if (nextNode != null) {
                node = nextNode;
                ++i;
            }
            else {
                while (i < len) {
                    Trie.Node newNode = new Trie.Node();
                    node.m_nextChar[Character.toUpperCase(key.charAt(i))] = newNode;
                    node.m_nextChar[Character.toLowerCase(key.charAt(i))] = newNode;
                    node = newNode;
                    ++i;
                }
                break;
            }
        }
        Object ret = node.m_Value;
        node.m_Value = value;
        return ret;
    }
    
    public Object get(String key) {
        int len = key.length();
        if (this.m_charBuffer.length < len) {
            return null;
        }
        Trie.Node node = this.m_Root;
        switch (len) {
            case 0: {
                return null;
            }
            case 1: {
                char ch = key.charAt(0);
                if (ch < '\u0080') {
                    node = node.m_nextChar[ch];
                    if (node != null) {
                        return node.m_Value;
                    }
                }
                return null;
            }
            default: {
                key.getChars(0, len, this.m_charBuffer, 0);
                int i = 0;
                while (i < len) {
                    char ch2 = this.m_charBuffer[i];
                    if ('\u0080' <= ch2) {
                        return null;
                    }
                    node = node.m_nextChar[ch2];
                    if (node == null) {
                        return null;
                    }
                    ++i;
                }
                return node.m_Value;
            }
        }
    }
    
    class Node
    {
        Trie.Node[] m_nextChar;
        Object m_Value;
        
        Node() {
            this.m_nextChar = new Trie.Node[128];
            this.m_Value = null;
        }
    }
}
